package de.wfink.ejb2.test.cmp.mapper;


import java.rmi.RemoteException;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientConfiguration;
import org.jboss.ejb.client.EJBClientContext;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.experimental.theories.suppliers.TestedOn;

import de.wfink.ejb2.examples.cmp.MapperCmpSession;
import de.wfink.ejb2.examples.cmp.MapperCmpSessionHome;

public class FieldMapperTest {
    //private static final String rcal = "ejb:/EJB2examples-cmp-fieldMapper/MapperCMPSession!" + MapperCmpSessionHome.class.getName();
    private static final String rcal = "ejb:EJB2examples-cmp-fieldMapper-ear/ejb/MapperCMPSession!" + MapperCmpSessionHome.class.getName();
    private static MapperCmpSession slsbRemote;
    private static InitialContext context;

    @BeforeClass
    static public void init() throws NamingException, RemoteException, CreateException {
        // suppress output of client messages
        Logger.getLogger("org.jboss").setLevel(Level.ALL);
        Logger.getLogger("org.xnio").setLevel(Level.ALL);

        Properties p = new Properties();
        p.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");
        p.put("remote.connections", "one");
        p.put("remote.connection.one.port", "4447");
        p.put("remote.connection.one.host", "localhost");
        p.put("remote.connection.one.username", "quickuser");
        p.put("remote.connection.one.password", "quick-123");

        EJBClientConfiguration cc = new PropertiesBasedEJBClientConfiguration(p);
        ContextSelector<EJBClientContext> selector = new ConfigBasedEJBClientContextSelector(cc);
        EJBClientContext.setSelector(selector);

        Properties props = new Properties();
        props.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        context = new InitialContext(props);

        System.out.println("Lookup  => " + rcal);
        slsbRemote = ((MapperCmpSessionHome) context.lookup(rcal)).create();
    }

    @AfterClass
    public static void shutdown() throws Exception {
        context.close();
    }

    public void createEntity() throws RemoteException {
        slsbRemote.createEntity(1L);
    }

    public void read() throws RemoteException {
        slsbRemote.getEntityName(1L);
    }

    public void removeEntity() throws RemoteException {
        slsbRemote.removeEntity(1L);
    }

    @Test
    public void test() throws RemoteException {
    	createEntity();
    	read();
    	removeEntity();
    }
}
